Project Chrono: chrono::vehicle::ChTrackWheel Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
chrono::vehicle::ChTrackWheel Class Referenceabstract
VEHICLE module » Tracked vehicles » Suspension subsystem

## Description

Base class for a track wheel subsystem.

`#include <ChTrackWheel.h>`

Inheritance diagram for chrono::vehicle::ChTrackWheel:
[legend]
Collaboration diagram for chrono::vehicle::ChTrackWheel:
[legend]

## Public Member Functions
virtual GuidePinType | GetType () const =0
| Return the type of track shoe consistent with this track wheel.
std::shared_ptr< ChBody > | GetBody () const
| Get a handle to the wheel body.
std::shared_ptr< ChLinkLockRevolute > | GetRevolute () const
| Get a handle to the revolute joint.
virtual double | GetMass () const =0
| Return the mass of the track wheel body.
virtual const ChVector3d & | GetInertia ()=0
| Return the moments of inertia of the track wheel body.
virtual double | GetRadius () const =0
| Get the radius of the track wheel.
virtual double | GetWidth () const =0
| Return the total width of the track wheel.
void | EnableCollision (bool val)
| Turn on/off collision flag for the track wheel (default: true).
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, std::shared_ptr< ChBody > carrier, const ChVector3d &location, ChTrackAssembly *track)
| Initialize this track wheel subsystem.
void | LogConstraintViolations ()
| Log current constraint violations.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const override
| Export this subsystem's component list to the specified JSON object.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
virtual std::string | GetTemplateName () const =0
| Get the name of the vehicle subsystem template.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | AddVisualizationAssets (VisualizationType vis)
| Add visualization assets to this subsystem, for the specified visualization mode.
virtual void | RemoveVisualizationAssets ()
| Remove all visualization assets from this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Protected Member Functions
| ChTrackWheel (const std::string &name)
| Construct a road-wheel subsystem with given name.
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
virtual void | CreateContactMaterial (ChContactMethod contact_method)=0
| Create the contact material consistent with the specified contact method.
virtual void | Output (ChVehicleOutput &database) const override
| Output data for this subsystem's component list to the specified database.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.

## Protected Attributes
std::shared_ptr< ChBody > | m_wheel
| track wheel body
std::shared_ptr< ChLinkLockRevolute > | m_revolute
| wheel revolute joint
std::shared_ptr< ChContactMaterial > | m_material
| contact material;
ChTrackAssembly * | m_track
| containing track assembly
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Friends
class | ChTrackAssembly

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).

## Member Function Documentation

## ◆ CreateContactMaterial()

virtual void chrono::vehicle::ChTrackWheel::CreateContactMaterial | ( | ChContactMethod | contact_method | ) |
| protectedpure virtual

Create the contact material consistent with the specified contact method.

Implemented in chrono::vehicle::m113::M113_IdlerWheel, chrono::vehicle::m113::M113_RoadWheel, chrono::vehicle::marder::Marder_IdlerWheel, chrono::vehicle::marder::Marder_RoadWheel, and chrono::vehicle::marder::Marder_SupportRoller.

## ◆ ExportComponentList()

void chrono::vehicle::ChTrackWheel::ExportComponentList | ( | rapidjson::Document & | jsonDocument | ) | const
| overridevirtual

Export this subsystem's component list to the specified JSON object.

Derived classes should override this function and first invoke the base class implementation, followed by calls to the various static Export***List functions, as appropriate.

Reimplemented from chrono::vehicle::ChPart.

## ◆ GetInertia()

virtual const ChVector3d & chrono::vehicle::ChTrackWheel::GetInertia | ( |  | ) |
| pure virtual

Return the moments of inertia of the track wheel body.

Implemented in chrono::vehicle::DoubleTrackWheel, chrono::vehicle::m113::M113_IdlerWheel, chrono::vehicle::m113::M113_RoadWheel, chrono::vehicle::marder::Marder_IdlerWheel, chrono::vehicle::marder::Marder_RoadWheel, chrono::vehicle::marder::Marder_SupportRoller, and chrono::vehicle::SingleTrackWheel.

## ◆ GetMass()

virtual double chrono::vehicle::ChTrackWheel::GetMass | ( |  | ) | const
| pure virtual

Return the mass of the track wheel body.

Implemented in chrono::vehicle::DoubleTrackWheel, chrono::vehicle::m113::M113_IdlerWheel, chrono::vehicle::m113::M113_RoadWheel, chrono::vehicle::marder::Marder_IdlerWheel, chrono::vehicle::marder::Marder_RoadWheel, chrono::vehicle::marder::Marder_SupportRoller, and chrono::vehicle::SingleTrackWheel.

## ◆ GetRadius()

virtual double chrono::vehicle::ChTrackWheel::GetRadius | ( |  | ) | const
| pure virtual

Get the radius of the track wheel.

Implemented in chrono::vehicle::DoubleTrackWheel, chrono::vehicle::m113::M113_IdlerWheel, chrono::vehicle::m113::M113_RoadWheel, chrono::vehicle::marder::Marder_IdlerWheel, chrono::vehicle::marder::Marder_RoadWheel, chrono::vehicle::marder::Marder_SupportRoller, and chrono::vehicle::SingleTrackWheel.

## ◆ GetType()

virtual GuidePinType chrono::vehicle::ChTrackWheel::GetType | ( |  | ) | const
| pure virtual

Return the type of track shoe consistent with this track wheel.

Implemented in chrono::vehicle::ChDoubleTrackWheel, and chrono::vehicle::ChSingleTrackWheel.

## ◆ GetWidth()

virtual double chrono::vehicle::ChTrackWheel::GetWidth | ( |  | ) | const
| pure virtual

Return the total width of the track wheel.

Implemented in chrono::vehicle::DoubleTrackWheel, chrono::vehicle::m113::M113_IdlerWheel, chrono::vehicle::m113::M113_RoadWheel, chrono::vehicle::marder::Marder_IdlerWheel, chrono::vehicle::marder::Marder_RoadWheel, chrono::vehicle::marder::Marder_SupportRoller, and chrono::vehicle::SingleTrackWheel.

## ◆ Initialize()

void chrono::vehicle::ChTrackWheel::Initialize | ( | std::shared_ptr< ChChassis > | chassis,
|  | std::shared_ptr< ChBody > | carrier,
|  | const ChVector3d & | location,
|  | ChTrackAssembly * | track )
| virtual

Initialize this track wheel subsystem.

The track wheel subsystem is initialized by attaching it to the specified carrier body at the specified location (with respect to and expressed in the reference frame of the chassis). It is assumed that the track wheel subsystem reference frame is always aligned with the chassis reference frame. A derived track wheel subsystem template class must extend this default implementation and specify contact geometry for the track wheel.

Parameters

  [in] | chassis | associated chassis subsystem
  [in] | carrier | carrier body
  [in] | location | location relative to the chassis frame
  [in] | track | containing track assembly

Reimplemented in chrono::vehicle::ChDoubleTrackWheel, and chrono::vehicle::ChSingleTrackWheel.

## ◆ InitializeInertiaProperties()

void chrono::vehicle::ChTrackWheel::InitializeInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Initialize subsystem inertia properties.

Derived classes must override this function and set the subsystem mass (m_mass) and, if constant, the subsystem COM frame and its inertia tensor. This function is called during initialization of the vehicle system.

Implements chrono::vehicle::ChPart.

## ◆ Output()

void chrono::vehicle::ChTrackWheel::Output | ( | ChVehicleOutput & | database | ) | const
| overrideprotectedvirtual

Output data for this subsystem's component list to the specified database.

Reimplemented from chrono::vehicle::ChPart.

## ◆ UpdateInertiaProperties()

void chrono::vehicle::ChTrackWheel::UpdateInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Update subsystem inertia properties.

Derived classes must override this function and set the global subsystem transform (m_xform) and, unless constant, the subsystem COM frame (m_com) and its inertia tensor (m_inertia). Calculate the current inertia properties and global frame of this subsystem. This function is called every time the state of the vehicle system is advanced in time.

Implements chrono::vehicle::ChPart.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/ChTrackWheel.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/ChTrackWheel.cpp